/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * MainJFrame.java
 *
 * Created on 2010/09/08, 12:28:20
 */

package picturestoryeditor;

import java.awt.Color;
import java.awt.Dialog;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import java.awt.event.KeyEvent;
import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.text.DecimalFormat;
import java.util.Collection;
import java.util.Locale;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.plaf.basic.BasicTextUI.BasicCaret;
import picturestoryeditor.encode.JDialog_Encode;

/**
 *
 * @author Administrator
 */
public class JFrame_Main extends javax.swing.JFrame implements Runnable{
    public static final int PREVIEW_WIDTH = 320;
    public static final int PREVIEW_HEIGHT = 240;
    public static final int PREVIEW_HEIGHT_WIDE = 180;
    public static final String APP_NAME = "Picture Story Editor";
    
    private Scene SelectedScene;
    private String OpenedFileName = "";
    private Rectangle PreviewRect = new Rectangle();

    private JDialog_Preview jDialog_Preview;
    private JDialog_Encode jDialog_Encode = null;

    private Thread previewThread;
    private Project project;
    private boolean previewMode = false;
    private boolean terminated = false;
    
    /** Creates new form MainJFrame */
    public JFrame_Main() {
        initComponents();
        setLocationRelativeTo(this);
        
        Graphics2D g2 = (Graphics2D) jPanel_Preview.getGraphics();
        g2.dispose();
        
        DefaultListModel m2 = new DefaultListModel();
        jList_Scene.setModel(m2);
        jList_Scene.setTransferHandler(new ListItemTransferHandler());
        
        DefaultComboBoxModel m = new DefaultComboBoxModel();
        jComboBox_Project_Resolution.setModel(m);

        for (Resolutions r : Resolutions.values()) {
            m.addElement(r);
        }

        jComboBox_Project_Resolution.setSelectedItem(Resolutions.Nico_Standard);

        m = new DefaultComboBoxModel();
        jComboBox_Project_Resize.setModel(m);

        for (AutoResizeType r : AutoResizeType.values()) {
            m.addElement(r);
        }

        jComboBox_Project_Resize.setSelectedItem(AutoResizeType.ASPECT_RATIO_HOLD);

        m = new DefaultComboBoxModel();
        jComboBox_Scene_Sound_BGM_Control.setModel(m);

        for (SoundControlType r : SoundControlType.values()) {
            m.addElement(r);
        }

        /*
        m = new DefaultComboBoxModel();
        jComboBox_Scene_Text_Position.setModel(m);

        for (TextPositionlType r : TextPositionlType.values()) {
            m.addElement(r);
        }
         *
         */

        
        m = new DefaultComboBoxModel();
        jComboBox_Scene_Change.setModel(m);

        for (ChangeEffectType r : ChangeEffectType.values()) {
            m.addElement(r);
        }

        resetScene();
        jComboBox_Scene_Change.setSelectedItem(ChangeEffectType.NORMAL);
        
        /*
         * 列挙体の説明をツールチップにする
         */
        String description = "<html>";
        for (AutoResizeType a : AutoResizeType.values()) {
            description += "<b>★" + a.getName() + "★</b><br>" + a.getDescription() + "<br><br>";
        }
        jComboBox_Project_Resize.setToolTipText(description);

        description = "<html>";
        for (ChangeEffectType a : ChangeEffectType.values()) {
            description += "<b>★" + a.getName() + "★</b><br>" + a.getDescription() + "<br><br>";
        }
        jComboBox_Scene_Change.setToolTipText(description);

        description = "<html>";
        for (SoundControlType a : SoundControlType.values()) {
            description += "<b>★" + a.getName() + "★</b><br>" + a.getDescription() + "<br><br>";
        }
        jComboBox_Scene_Sound_BGM_Control.setToolTipText(description);
}

    public final void resetScene() {
        jTextField_Scene_Sound_SE.setText("");
        jComboBox_Scene_Sound_BGM_Control.setSelectedItem(SoundControlType.NONE);

        /*
        jTextArea_Scene_Text.setText("");
        jComboBox_Scene_Text_Position.setSelectedItem(TextPositionlType.HIDE);
         *
         */
    }

    public void SceneToForm(Scene s) {
        jTextField_Scene_Name.setText(s.base_Name);
        jSpinner_Scene_Time.setValue(s.base_Time);
        jTextField_Scene_Image.setText(s.base_ImageFile);

        jTextField_Scene_Sound_BGM.setText(s.sound_BGMFile);
        jTextField_Scene_Sound_SE.setText(s.sound_SEFile);
        jCheckBox_Scene_Sound_BGM_Loop.setSelected(s.sound_LoopEnabled);
        jSpinner_Scene_Sound_BGM_Volume.setValue(s.sound_Volume);
        jComboBox_Scene_Sound_BGM_Control.setSelectedItem(s.sound_Control);

        /*
        jTextArea_Scene_Text.setText(s.text_Body);
        jComboBox_Scene_Text_Position.setSelectedItem(s.text_Position);
         *
         */
        
        jComboBox_Scene_Change.setSelectedItem(s.change_Effect);
        jSpinner_Scene_Change_Time.setValue(s.change_Time);
        jTextField_Scene_Change_RuleImage.setText(s.change_RuleImageFile);
    }

    public void FormToScene(Scene s) {
        s.base_Name = jTextField_Scene_Name.getText();
        s.base_Time = (Double)jSpinner_Scene_Time.getValue();
        s.base_ImageFile = jTextField_Scene_Image.getText();

        s.sound_BGMFile = jTextField_Scene_Sound_BGM.getText();
        s.sound_SEFile = jTextField_Scene_Sound_SE.getText();
        s.sound_LoopEnabled = jCheckBox_Scene_Sound_BGM_Loop.isSelected();
        s.sound_Volume = (Integer)jSpinner_Scene_Sound_BGM_Volume.getValue();
        s.sound_Control = (SoundControlType) jComboBox_Scene_Sound_BGM_Control.getSelectedItem();

        /*
        s.text_Body = jTextArea_Scene_Text.getText();
        s.text_Position = (TextPositionlType) jComboBox_Scene_Text_Position.getSelectedItem();
         * 
         */
        
        s.change_Effect = (ChangeEffectType) jComboBox_Scene_Change.getSelectedItem();
        s.change_Time = (Double)jSpinner_Scene_Change_Time.getValue();
        s.change_RuleImageFile = jTextField_Scene_Change_RuleImage.getText();
    }

    public void SelectListItem() {
        if (SelectedScene != null) {
            FormToScene(SelectedScene);
        }
        
        SceneToForm((Scene)jList_Scene.getSelectedValue());
        SelectedScene = (Scene)jList_Scene.getSelectedValue();
    }

    public void showPreview() {
        if (previewMode) return;

        jPanel_Preview.paintImmediately(0, 0, jPanel_Preview.getWidth(), jPanel_Preview.getHeight());

        if (jList_Scene.isSelectionEmpty()) {
            return;
        }

        File f = new File(((Scene)jList_Scene.getSelectedValue()).base_ImageFile);
        //画像ファイルが存在する場合のみプレビュー
        if (f.exists()) {
            Project p = new Project();
            p.project_FPS = (Integer)jSpinner_Project_FPS.getValue();
            p.project_Resize = (AutoResizeType) jComboBox_Project_Resize.getSelectedItem();
            p.project_Resolution = (Resolutions) jComboBox_Project_Resolution.getSelectedItem();
            //p.RenderBegin(0);
            BufferedImage image = p.RenderScene((Scene) jList_Scene.getSelectedValue());
            if (image == null) return;

            Graphics2D g2 = (Graphics2D) jPanel_Preview.getGraphics();
            g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
            g2.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR);
            //g2.setBackground(jPanel_Preview.getBackground());
            //g2.clearRect(0, 0, jPanel_Preview.getWidth(), jPanel_Preview.getHeight());
            g2.drawImage(image, PreviewRect.x, PreviewRect.y, PreviewRect.width, PreviewRect.height, null);
            g2.dispose();
            //canvas_Preview.getBufferStrategy().show();
            //p.RenderEnd();
        }
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jList_Scene = new javax.swing.JList();
        jButton_Scene_Delete = new javax.swing.JButton();
        jButton_Scene_Add = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jTabbedPane_Scene = new javax.swing.JTabbedPane();
        jPanel5 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jSpinner_Scene_Time = new javax.swing.JSpinner();
        jLabel5 = new javax.swing.JLabel();
        jTextField_Scene_Image = new javax.swing.JTextField("");
        jLabel6 = new javax.swing.JLabel();
        jButton_Scene_Image = new javax.swing.JButton();
        jButton_Scene_TimeAll = new javax.swing.JButton();
        jTextField_Scene_Name = new javax.swing.JTextField("");
        jLabel14 = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        jPanel9 = new javax.swing.JPanel();
        jButton_Scene_Sound_SE = new javax.swing.JButton();
        jTextField_Scene_Sound_SE = new javax.swing.JTextField("");
        jPanel10 = new javax.swing.JPanel();
        jButton_Scene_Sound_BGM = new javax.swing.JButton();
        jTextField_Scene_Sound_BGM = new javax.swing.JTextField("");
        jComboBox_Scene_Sound_BGM_Control = new javax.swing.JComboBox();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jSpinner_Scene_Sound_BGM_Volume = new javax.swing.JSpinner();
        jCheckBox_Scene_Sound_BGM_Loop = new javax.swing.JCheckBox();
        jLabel15 = new javax.swing.JLabel();
        jPanel8 = new javax.swing.JPanel();
        jButton_Scene_Change_RuleImage = new javax.swing.JButton();
        jTextField_Scene_Change_RuleImage = new javax.swing.JTextField("");
        jLabel8 = new javax.swing.JLabel();
        jComboBox_Scene_Change = new javax.swing.JComboBox();
        jLabel9 = new javax.swing.JLabel();
        jSpinner_Scene_Change_Time = new javax.swing.JSpinner();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jSpinner_Project_FPS = new javax.swing.JSpinner();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jComboBox_Project_Resolution = new javax.swing.JComboBox();
        jLabel3 = new javax.swing.JLabel();
        jComboBox_Project_Resize = new javax.swing.JComboBox();
        jButton_Project_Open = new javax.swing.JButton();
        jButton_Project_Save = new javax.swing.JButton();
        jButton_Project_Encode = new javax.swing.JButton();
        jButton_Project_Preview = new javax.swing.JButton();
        jPanel_Preview = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Picture Story Editor");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowActivated(java.awt.event.WindowEvent evt) {
                formWindowActivated(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "シーンリスト", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("MS UI Gothic", 0, 16), new java.awt.Color(0, 0, 0))); // NOI18N

        jScrollPane1.setFont(jScrollPane1.getFont().deriveFont((float)16));

        jList_Scene.setFont(jList_Scene.getFont().deriveFont((float)16));
        jList_Scene.setToolTipText("<html>動画を構成する、シーンの一覧が表示されます。<br>動画では、上にあるシーンから順に再生されます。<br>シーンを選択すると、その内容が「シーンの設定」に表示され、編集できます。<br>ドラッグ＆ドロップで順番を変更できます。");
        jList_Scene.setDragEnabled(true);
        jList_Scene.setDropMode(javax.swing.DropMode.INSERT);
        jList_Scene.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jList_SceneValueChanged(evt);
            }
        });
        jList_Scene.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jList_SceneKeyPressed(evt);
            }
        });
        jScrollPane1.setViewportView(jList_Scene);

        jButton_Scene_Delete.setFont(jButton_Scene_Delete.getFont().deriveFont((float)16));
        jButton_Scene_Delete.setText("削除");
        jButton_Scene_Delete.setToolTipText("シーンリストで選択されたシーンを削除します。");
        jButton_Scene_Delete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_Scene_DeleteActionPerformed(evt);
            }
        });

        jButton_Scene_Add.setFont(jButton_Scene_Add.getFont().deriveFont((float)16));
        jButton_Scene_Add.setText("追加");
        jButton_Scene_Add.setToolTipText("<html>「シーンの設定」で編集したシーンを、シーンリストに追加します。<br>シーンを選択している場合はその下に、それ以外は末尾に追加されます。");
        jButton_Scene_Add.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_Scene_AddActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 289, Short.MAX_VALUE)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jButton_Scene_Add)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 159, Short.MAX_VALUE)
                        .addComponent(jButton_Scene_Delete)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 220, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton_Scene_Add, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton_Scene_Delete, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "シーンの設定", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("MS UI Gothic", 0, 16), new java.awt.Color(0, 0, 0))); // NOI18N

        jTabbedPane_Scene.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        jTabbedPane_Scene.setFont(jTabbedPane_Scene.getFont().deriveFont((float)16));

        jPanel5.setBackground(new java.awt.Color(255, 255, 255));

        jLabel4.setFont(jLabel4.getFont().deriveFont((float)16));
        jLabel4.setText("表示時間：");
        jLabel4.setToolTipText("<html>このシーンが表示される時間。<br>設定した時間が経過すると、次のシーンに切り替わります。");

        jSpinner_Scene_Time.setFont(jSpinner_Scene_Time.getFont().deriveFont((float)16));
        jSpinner_Scene_Time.setModel(new javax.swing.SpinnerNumberModel(Double.valueOf(3.0d), null, null, Double.valueOf(0.1d)));
        jSpinner_Scene_Time.setToolTipText("ここに、表示時間を半角数字で入力します。小数または整数が使用できます。");
        jSpinner_Scene_Time.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jSpinner_Scene_TimeMouseEntered(evt);
            }
        });

        jLabel5.setFont(jLabel5.getFont().deriveFont((float)16));
        jLabel5.setText("秒");

        jTextField_Scene_Image.setFont(jTextField_Scene_Image.getFont().deriveFont((float)16));
        jTextField_Scene_Image.setToolTipText("ここに、画像のファイルパスを入力します。");

        jLabel6.setFont(jLabel6.getFont().deriveFont((float)16));
        jLabel6.setText("画像：");
        jLabel6.setToolTipText("このシーンで使用される画像のファイル名。");

        jButton_Scene_Image.setFont(jButton_Scene_Image.getFont().deriveFont((float)16));
        jButton_Scene_Image.setText("参照");
        jButton_Scene_Image.setToolTipText("このボタンを押すと、ファイル選択ダイアログが開き、選択されたファイルのパスがテキストボックスに設定されます。");
        jButton_Scene_Image.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_Scene_ImageActionPerformed(evt);
            }
        });

        jButton_Scene_TimeAll.setFont(jButton_Scene_TimeAll.getFont().deriveFont((float)16));
        jButton_Scene_TimeAll.setText("全シーンに設定");
        jButton_Scene_TimeAll.setToolTipText("このボタンを押すと、全てのシーンの表示時間が、このシーンと同じになります。");
        jButton_Scene_TimeAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_Scene_TimeAllActionPerformed(evt);
            }
        });

        jTextField_Scene_Name.setFont(jTextField_Scene_Name.getFont().deriveFont((float)16));
        jTextField_Scene_Name.setToolTipText("ここにシーン名を適当に入力します。");

        jLabel14.setFont(jLabel14.getFont().deriveFont((float)16));
        jLabel14.setText("シーン名：");
        jLabel14.setToolTipText("<html>シーンの内容が分かるようにするためのものです。<br>動画には使用されません。");

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(jLabel14)
                        .addGap(18, 18, 18)
                        .addComponent(jTextField_Scene_Name, javax.swing.GroupLayout.DEFAULT_SIZE, 262, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createSequentialGroup()
                        .addComponent(jTextField_Scene_Image, javax.swing.GroupLayout.DEFAULT_SIZE, 265, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton_Scene_Image))
                    .addComponent(jLabel6)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel4)
                            .addComponent(jSpinner_Scene_Time, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 45, Short.MAX_VALUE)
                        .addComponent(jButton_Scene_TimeAll, javax.swing.GroupLayout.PREFERRED_SIZE, 146, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGap(19, 19, 19)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel14)
                    .addComponent(jTextField_Scene_Name, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(27, 27, 27)
                .addComponent(jLabel6)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField_Scene_Image, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton_Scene_Image, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGap(26, 26, 26)
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jSpinner_Scene_Time, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel5)))
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGap(41, 41, 41)
                        .addComponent(jButton_Scene_TimeAll, javax.swing.GroupLayout.DEFAULT_SIZE, 40, Short.MAX_VALUE)))
                .addContainerGap(22, Short.MAX_VALUE))
        );

        jTabbedPane_Scene.addTab("基本", jPanel5);

        jPanel6.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.highlight"));

        jPanel9.setBackground(new java.awt.Color(255, 255, 255));
        jPanel9.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "効果音", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("MS UI Gothic", 0, 16), new java.awt.Color(0, 0, 0))); // NOI18N
        jPanel9.setToolTipText("このシーンの表示時間+切替時間の間、再生されます。");

        jButton_Scene_Sound_SE.setFont(jButton_Scene_Sound_SE.getFont().deriveFont((float)16));
        jButton_Scene_Sound_SE.setText("参照");
        jButton_Scene_Sound_SE.setToolTipText("このボタンを押すと、ファイル選択ダイアログが開き、選択された効果音ファイルのパスがテキストボックスに設定されます。");
        jButton_Scene_Sound_SE.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_Scene_Sound_SEActionPerformed(evt);
            }
        });

        jTextField_Scene_Sound_SE.setFont(jTextField_Scene_Sound_SE.getFont().deriveFont((float)16));
        jTextField_Scene_Sound_SE.setToolTipText("ここに、効果音のファイルパスを入力します。");

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTextField_Scene_Sound_SE, javax.swing.GroupLayout.DEFAULT_SIZE, 243, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addComponent(jButton_Scene_Sound_SE))
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField_Scene_Sound_SE, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton_Scene_Sound_SE, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel10.setBackground(new java.awt.Color(255, 255, 255));
        jPanel10.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "BGM", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("MS UI Gothic", 0, 16), new java.awt.Color(0, 0, 0))); // NOI18N
        jPanel10.setToolTipText("停止するまで再生され続けます。");

        jButton_Scene_Sound_BGM.setFont(jButton_Scene_Sound_BGM.getFont().deriveFont((float)16));
        jButton_Scene_Sound_BGM.setText("参照");
        jButton_Scene_Sound_BGM.setToolTipText("このボタンを押すと、ファイル選択ダイアログが開き、選択されたBGMファイルのパスがテキストボックスに設定されます。");
        jButton_Scene_Sound_BGM.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_Scene_Sound_BGMActionPerformed(evt);
            }
        });

        jTextField_Scene_Sound_BGM.setFont(jTextField_Scene_Sound_BGM.getFont().deriveFont((float)16));
        jTextField_Scene_Sound_BGM.setToolTipText("ここに、BGMのファイルパスを入力します。");

        jComboBox_Scene_Sound_BGM_Control.setFont(jComboBox_Scene_Sound_BGM_Control.getFont().deriveFont((float)16));

        jLabel12.setFont(jLabel12.getFont().deriveFont((float)16));
        jLabel12.setText("操作：");
        jLabel12.setToolTipText("BGMの状態を変更します。");

        jLabel13.setFont(jLabel13.getFont().deriveFont((float)16));
        jLabel13.setText("音量：");
        jLabel13.setToolTipText("♪");

        jSpinner_Scene_Sound_BGM_Volume.setFont(jSpinner_Scene_Sound_BGM_Volume.getFont().deriveFont((float)16));
        jSpinner_Scene_Sound_BGM_Volume.setModel(new javax.swing.SpinnerNumberModel(60, 0, 100, 1));
        jSpinner_Scene_Sound_BGM_Volume.setToolTipText("<html>ここに、BGMの音量を半角数字で入力します。<br>整数のみ使用できます。");

        jCheckBox_Scene_Sound_BGM_Loop.setBackground(new java.awt.Color(255, 255, 255));
        jCheckBox_Scene_Sound_BGM_Loop.setFont(new java.awt.Font("MS UI Gothic", 0, 16));
        jCheckBox_Scene_Sound_BGM_Loop.setText("ループ");
        jCheckBox_Scene_Sound_BGM_Loop.setToolTipText("有効にすると、終端に達しても停止せずに最初から再生しなおします。");

        jLabel15.setFont(jLabel15.getFont().deriveFont((float)16));
        jLabel15.setText("％");

        javax.swing.GroupLayout jPanel10Layout = new javax.swing.GroupLayout(jPanel10);
        jPanel10.setLayout(jPanel10Layout);
        jPanel10Layout.setHorizontalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel10Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel10Layout.createSequentialGroup()
                        .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel12)
                            .addComponent(jComboBox_Scene_Sound_BGM_Control, javax.swing.GroupLayout.PREFERRED_SIZE, 131, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 19, Short.MAX_VALUE)
                        .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel10Layout.createSequentialGroup()
                                .addComponent(jSpinner_Scene_Sound_BGM_Volume, javax.swing.GroupLayout.PREFERRED_SIZE, 66, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel15))
                            .addComponent(jLabel13))
                        .addGap(6, 6, 6))
                    .addComponent(jTextField_Scene_Sound_BGM, javax.swing.GroupLayout.DEFAULT_SIZE, 243, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel10Layout.createSequentialGroup()
                        .addComponent(jCheckBox_Scene_Sound_BGM_Loop)
                        .addContainerGap())
                    .addComponent(jButton_Scene_Sound_BGM)))
        );
        jPanel10Layout.setVerticalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel10Layout.createSequentialGroup()
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField_Scene_Sound_BGM, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton_Scene_Sound_BGM, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel10Layout.createSequentialGroup()
                        .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel12)
                            .addComponent(jLabel13))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jComboBox_Scene_Sound_BGM_Control, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel15)
                            .addComponent(jSpinner_Scene_Sound_BGM_Volume, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanel10Layout.createSequentialGroup()
                        .addGap(31, 31, 31)
                        .addComponent(jCheckBox_Scene_Sound_BGM_Loop)))
                .addContainerGap())
        );

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel6Layout.createSequentialGroup()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel9, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel10, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, 154, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jTabbedPane_Scene.addTab("音声", jPanel6);

        jPanel8.setBackground(new java.awt.Color(255, 255, 255));

        jButton_Scene_Change_RuleImage.setFont(jButton_Scene_Change_RuleImage.getFont().deriveFont((float)16));
        jButton_Scene_Change_RuleImage.setText("参照");
        jButton_Scene_Change_RuleImage.setToolTipText("このボタンを押すと、ファイル選択ダイアログが開き、選択されたルール画像ファイルのパスがテキストボックスに設定されます。");
        jButton_Scene_Change_RuleImage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_Scene_Change_RuleImageActionPerformed(evt);
            }
        });

        jTextField_Scene_Change_RuleImage.setFont(jTextField_Scene_Change_RuleImage.getFont().deriveFont((float)16));
        jTextField_Scene_Change_RuleImage.setToolTipText("ここに、BGMのファイルパスを入力します。");

        jLabel8.setFont(jLabel8.getFont().deriveFont((float)16));
        jLabel8.setText("トランジション用ルール画像：");
        jLabel8.setToolTipText("切替方法にトランジションを選択している場合のみ有効です。");

        jComboBox_Scene_Change.setFont(jComboBox_Scene_Change.getFont().deriveFont((float)16));

        jLabel9.setFont(jLabel9.getFont().deriveFont((float)16));
        jLabel9.setText("切替方法：");
        jLabel9.setToolTipText("このシーンから次のシーンへ切り替わる際の、アニメーションの方法。");

        jSpinner_Scene_Change_Time.setFont(jSpinner_Scene_Change_Time.getFont().deriveFont((float)16));
        jSpinner_Scene_Change_Time.setModel(new javax.swing.SpinnerNumberModel(Double.valueOf(0.0d), Double.valueOf(0.0d), null, Double.valueOf(0.1d)));
        jSpinner_Scene_Change_Time.setToolTipText("<html>ここに、切替時間を半角数字で入力します。<br>整数および小数が使用できます。");

        jLabel10.setFont(jLabel10.getFont().deriveFont((float)16));
        jLabel10.setText("切替時間：");
        jLabel10.setToolTipText("切替時のアニメーションの時間。");

        jLabel11.setFont(jLabel11.getFont().deriveFont((float)16));
        jLabel11.setText("秒");

        javax.swing.GroupLayout jPanel8Layout = new javax.swing.GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel8Layout.createSequentialGroup()
                        .addComponent(jLabel10)
                        .addGap(18, 18, 18)
                        .addComponent(jSpinner_Scene_Change_Time, javax.swing.GroupLayout.PREFERRED_SIZE, 82, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel11))
                    .addGroup(jPanel8Layout.createSequentialGroup()
                        .addComponent(jLabel9)
                        .addGap(18, 18, 18)
                        .addComponent(jComboBox_Scene_Change, javax.swing.GroupLayout.PREFERRED_SIZE, 173, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jLabel8)
                    .addGroup(jPanel8Layout.createSequentialGroup()
                        .addComponent(jTextField_Scene_Change_RuleImage, javax.swing.GroupLayout.PREFERRED_SIZE, 245, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton_Scene_Change_RuleImage)))
                .addContainerGap(32, Short.MAX_VALUE))
        );
        jPanel8Layout.setVerticalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addGap(24, 24, 24)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel9)
                    .addComponent(jComboBox_Scene_Change, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(40, 40, 40)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel10)
                    .addComponent(jSpinner_Scene_Change_Time, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel11))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 36, Short.MAX_VALUE)
                .addComponent(jLabel8)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField_Scene_Change_RuleImage, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton_Scene_Change_RuleImage, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(20, 20, 20))
        );

        jTabbedPane_Scene.addTab("切替", jPanel8);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap(15, Short.MAX_VALUE)
                .addComponent(jTabbedPane_Scene, javax.swing.GroupLayout.PREFERRED_SIZE, 371, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jTabbedPane_Scene, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "プロジェクトの設定", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("MS UI Gothic", 0, 16), new java.awt.Color(0, 0, 0))); // NOI18N

        jSpinner_Project_FPS.setFont(jSpinner_Project_FPS.getFont().deriveFont((float)16));
        jSpinner_Project_FPS.setModel(new javax.swing.SpinnerNumberModel(20, 1, 30, 1));
        jSpinner_Project_FPS.setToolTipText("<html>ここにFPSを、半角数字で入力します。<br>整数のみ使用できます。<br><br>切替方法が" + ChangeEffectType.NORMAL.getName() + "以外なら20もあれば十分です。");

        jLabel1.setFont(jLabel1.getFont().deriveFont((float)16));
        jLabel1.setText("FPS：");
        jLabel1.setToolTipText("1秒間に画面を書き換える回数。");

        jLabel2.setFont(jLabel2.getFont().deriveFont((float)16));
        jLabel2.setText("解像度：");
        jLabel2.setToolTipText("動画の幅・高さ。");

        jComboBox_Project_Resolution.setFont(jComboBox_Project_Resolution.getFont().deriveFont((float)16));
        jComboBox_Project_Resolution.setToolTipText("ご自由にお選びください。");
        jComboBox_Project_Resolution.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox_Project_ResolutionActionPerformed(evt);
            }
        });

        jLabel3.setFont(jLabel3.getFont().deriveFont((float)16));
        jLabel3.setText("リサイズ：");
        jLabel3.setToolTipText("ここで指定した方法で、画像の解像度を動画の解像度に合わせます。");

        jComboBox_Project_Resize.setFont(jComboBox_Project_Resize.getFont().deriveFont((float)16));
        jComboBox_Project_Resize.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox_Project_ResizeActionPerformed(evt);
            }
        });

        jButton_Project_Open.setFont(jButton_Project_Open.getFont().deriveFont((float)16));
        jButton_Project_Open.setText("開く");
        jButton_Project_Open.setToolTipText("データをプロジェクトファイルから読み込み、作業を再開できます。");
        jButton_Project_Open.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_Project_OpenActionPerformed(evt);
            }
        });

        jButton_Project_Save.setFont(jButton_Project_Save.getFont().deriveFont((float)16));
        jButton_Project_Save.setText("保存");
        jButton_Project_Save.setToolTipText("データをプロジェクトファイルに保存し、作業を中断できます。");
        jButton_Project_Save.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_Project_SaveActionPerformed(evt);
            }
        });

        jButton_Project_Encode.setFont(jButton_Project_Encode.getFont().deriveFont((float)16));
        jButton_Project_Encode.setText("エンコード");
        jButton_Project_Encode.setToolTipText("<html>動画をMP4形式にエンコードします。<br>出力したファイルは動画サイト等にアップロードできます。");
        jButton_Project_Encode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_Project_EncodeActionPerformed(evt);
            }
        });

        jButton_Project_Preview.setFont(jButton_Project_Preview.getFont().deriveFont((float)16));
        jButton_Project_Preview.setText("プレビュー");
        jButton_Project_Preview.setToolTipText("<html>動画の内容を確認します。<br>エンコードした結果とは異なる可能性があります。<br>シーンリストで選択したシーンからプレビューを開始します。");
        jButton_Project_Preview.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_Project_PreviewActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addGap(18, 18, 18)
                                .addComponent(jComboBox_Project_Resolution, 0, 215, Short.MAX_VALUE))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addGap(19, 19, 19)
                                .addComponent(jLabel1)
                                .addGap(18, 18, 18)
                                .addComponent(jSpinner_Project_FPS, javax.swing.GroupLayout.PREFERRED_SIZE, 66, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                                .addComponent(jLabel3)
                                .addGap(18, 18, 18)
                                .addComponent(jComboBox_Project_Resize, 0, 215, Short.MAX_VALUE))))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addGap(48, 48, 48)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(jButton_Project_Preview)
                                .addGap(33, 33, 33)
                                .addComponent(jButton_Project_Encode))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                                .addGap(18, 18, 18)
                                .addComponent(jButton_Project_Open)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jButton_Project_Save)
                                .addGap(15, 15, 15)))))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jSpinner_Project_FPS, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1))
                .addGap(21, 21, 21)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jComboBox_Project_Resolution, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addGap(27, 27, 27)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jComboBox_Project_Resize, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton_Project_Save, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton_Project_Open, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(27, 27, 27)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton_Project_Encode, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton_Project_Preview, javax.swing.GroupLayout.DEFAULT_SIZE, 36, Short.MAX_VALUE))
                .addContainerGap())
        );

        jPanel_Preview.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "シーンのプレビュー", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("MS UI Gothic", 0, 16), new java.awt.Color(0, 0, 0))); // NOI18N

        javax.swing.GroupLayout jPanel_PreviewLayout = new javax.swing.GroupLayout(jPanel_Preview);
        jPanel_Preview.setLayout(jPanel_PreviewLayout);
        jPanel_PreviewLayout.setHorizontalGroup(
            jPanel_PreviewLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 386, Short.MAX_VALUE)
        );
        jPanel_PreviewLayout.setVerticalGroup(
            jPanel_PreviewLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 282, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel_Preview, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel_Preview, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton_Scene_AddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_Scene_AddActionPerformed
        Scene s = new Scene();
        FormToScene(s);
        DefaultListModel m = (DefaultListModel) jList_Scene.getModel();
        SelectedScene = null;
        if (jList_Scene.isSelectionEmpty()) {
            m.addElement(s);
            jList_Scene.setSelectedIndex(m.size() - 1);
        }
        else {
            int index = jList_Scene.getSelectedIndex() + 1;
            m.insertElementAt(s, index);
            jList_Scene.clearSelection();
            jList_Scene.setSelectedIndex(index);
        }
    }//GEN-LAST:event_jButton_Scene_AddActionPerformed

    private void jButton_Scene_ImageActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_Scene_ImageActionPerformed
        JFileChooser f = new JFileChooser();
        f.setFileFilter(new ImageFileFilter());
        f.setMultiSelectionEnabled(false);
        f.setSelectedFile(new File(jTextField_Scene_Image.getText()));
        f.setDialogTitle("画像を選択");

        if (JFileChooser.APPROVE_OPTION == f.showOpenDialog(this)) {
            String s = f.getSelectedFile().getAbsolutePath();
            int index = s.lastIndexOf(File.separator) + 1;
            jTextField_Scene_Image.setText(s);
            
            if ((index >= 0) && jTextField_Scene_Name.getText().isEmpty()) jTextField_Scene_Name.setText(s.substring(index));
        }
    }//GEN-LAST:event_jButton_Scene_ImageActionPerformed

    private void jButton_Scene_Sound_BGMActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_Scene_Sound_BGMActionPerformed
        JFileChooser f = new JFileChooser();
        f.setFileFilter(new SoundFileFilter());
        f.setMultiSelectionEnabled(false);
        f.setSelectedFile(new File(jTextField_Scene_Sound_BGM.getText()));
        f.setDialogTitle("BGMを選択");

        if (JFileChooser.APPROVE_OPTION == f.showOpenDialog(this)) {
            jTextField_Scene_Sound_BGM.setText(f.getSelectedFile().getAbsolutePath());
        }
    }//GEN-LAST:event_jButton_Scene_Sound_BGMActionPerformed

    private void jButton_Scene_Sound_SEActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_Scene_Sound_SEActionPerformed
        JFileChooser f = new JFileChooser();
        f.setFileFilter(new SoundFileFilter());
        f.setMultiSelectionEnabled(false);
        f.setSelectedFile(new File(jTextField_Scene_Sound_SE.getText()));
        f.setDialogTitle("効果音を選択");

        if (JFileChooser.APPROVE_OPTION == f.showOpenDialog(this)) {
            jTextField_Scene_Sound_SE.setText(f.getSelectedFile().getAbsolutePath());
        }
}//GEN-LAST:event_jButton_Scene_Sound_SEActionPerformed

    private void jButton_Scene_DeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_Scene_DeleteActionPerformed
        if (jList_Scene.isSelectionEmpty()) {
            JOptionPane.showMessageDialog(this, "削除するシーンを選択して下さい。", "Error", JDialog.ERROR);
        }
        else {
            DefaultListModel m = (DefaultListModel) jList_Scene.getModel();
            int[] sel = jList_Scene.getSelectedIndices();
             
            //昇順にソート
            java.util.Arrays.sort(sel);

            //インデックスが変わるのを防ぐため、後ろから削除する
            for (int i = sel.length - 1; i >= 0; --i) {
                 m.remove(sel[i]);
            }
        }
        
    }//GEN-LAST:event_jButton_Scene_DeleteActionPerformed

    private void jButton_Scene_TimeAllActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_Scene_TimeAllActionPerformed
        if (jList_Scene.isSelectionEmpty()) {
            JOptionPane.showMessageDialog(this, "シーンがありません。", "Error", JDialog.ERROR);
        }
        else {
            DefaultListModel m = (DefaultListModel) jList_Scene.getModel();

            for (Object o : m.toArray()) {
                ((Scene)o).base_Time = (Double)jSpinner_Scene_Time.getValue();
            }
            JOptionPane.showMessageDialog(this, "全てのシーンの表示時間を\"" + Double.toString((Double)jSpinner_Scene_Time.getValue()) + "秒\"設定しました。", "Error", JDialog.ERROR);
        }
        
    }//GEN-LAST:event_jButton_Scene_TimeAllActionPerformed

    private void jList_SceneKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jList_SceneKeyPressed
        switch (evt.getKeyCode()) {
            case KeyEvent.VK_DELETE: {
                jButton_Scene_DeleteActionPerformed(null);
                break;
            }
            
            //Enterでシーンの設定を表示
            case KeyEvent.VK_ENTER: {
                if (!jList_Scene.isSelectionEmpty()) {
                    SelectListItem();
                    break;
                }
            }
        }
    }//GEN-LAST:event_jList_SceneKeyPressed

    private void jComboBox_Project_ResolutionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox_Project_ResolutionActionPerformed
        //プレビューの解像度(比率)を変更
        if (((Resolutions)jComboBox_Project_Resolution.getSelectedItem()).isWideFlag()) PreviewRect.setSize(PREVIEW_WIDTH, PREVIEW_HEIGHT_WIDE);
        else PreviewRect.setSize(PREVIEW_WIDTH, PREVIEW_HEIGHT);

        PreviewRect.x = (jPanel_Preview.getWidth() - PreviewRect.width) / 2;
        PreviewRect.y = (jPanel_Preview.getHeight() - PreviewRect.height) / 2;

        showPreview();
    }//GEN-LAST:event_jComboBox_Project_ResolutionActionPerformed

    private void jButton_Project_OpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_Project_OpenActionPerformed
        if (JOptionPane.YES_OPTION != JOptionPane.showConfirmDialog(this, "現在の内容を破棄してもよろしいですか？", "Confirm", JOptionPane.YES_NO_OPTION)) {
            return;
        }
        
        //ダイアログを作成
        JFileChooser f = new JFileChooser();
        f.setDialogType(JFileChooser.OPEN_DIALOG);
        f.setFileFilter(new ProjectFileFilter());
        f.setMultiSelectionEnabled(false);
        f.setSelectedFile(new File(OpenedFileName));
        f.setDialogTitle("プロジェクトファイルを選択");

        //ダイアログを開く
        if (JFileChooser.APPROVE_OPTION == f.showOpenDialog(this)) {
            
            OpenedFileName = f.getSelectedFile().getAbsolutePath();
            this.setTitle(f.getSelectedFile().getName() + " - " + APP_NAME);

            //プロジェクトの内容を読み込み
            Project p = new Project();
            p.LoadFromINI(OpenedFileName);
            
            jSpinner_Project_FPS.setValue(p.project_FPS);
            jComboBox_Project_Resize.setSelectedItem(p.project_Resize);
            jComboBox_Project_Resolution.setSelectedItem(p.project_Resolution);
            
            DefaultListModel model = (DefaultListModel) jList_Scene.getModel();
            model.clear();

            for (Scene s : p.SceneList) {
                model.addElement(s);
            }
        }
    }//GEN-LAST:event_jButton_Project_OpenActionPerformed

    public Project FormToProject() {
        Project p = new Project();
        p.project_FPS = (Integer)jSpinner_Project_FPS.getValue();
        p.project_Resize = (AutoResizeType) jComboBox_Project_Resize.getSelectedItem();
        p.project_Resolution = (Resolutions) jComboBox_Project_Resolution.getSelectedItem();

        DefaultListModel model = (DefaultListModel) jList_Scene.getModel();
        for (Object o : model.toArray()) {
            p.SceneList.add((Scene) o);
        }
        return p;
    }
    private void jButton_Project_SaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_Project_SaveActionPerformed
        //ダイアログを作成
        JFileChooser f = new JFileChooser();
        f.setDialogType(JFileChooser.SAVE_DIALOG);
        f.setFileFilter(new ProjectFileFilter());
        f.setMultiSelectionEnabled(false);
        f.setSelectedFile(new File(OpenedFileName));
        f.setDialogTitle("プロジェクトファイルを保存");
        
        //ダイアログを開く
        if (JFileChooser.APPROVE_OPTION == f.showSaveDialog(this)) {
            OpenedFileName = f.getSelectedFile().getAbsolutePath();
            
            //規定の拡張子ではない場合は末尾に付加
            if (!OpenedFileName.toLowerCase(Locale.ENGLISH).endsWith(ProjectFileFilter.SUPPORT_EXTENSION[0])) {
                OpenedFileName += ProjectFileFilter.SUPPORT_EXTENSION[0];
            }
            this.setTitle((new File(OpenedFileName)).getName() + " - " + APP_NAME);
            
            //プロジェクトの内容を保存
            if (SelectedScene != null) {
                FormToScene(SelectedScene);
            }
            Project p = FormToProject();
            
            p.SaveToINI(OpenedFileName);
            
        }
    }//GEN-LAST:event_jButton_Project_SaveActionPerformed

    private void jList_SceneValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jList_SceneValueChanged
        if (jList_Scene.isSelectionEmpty()) return;
        showPreview();
        SelectListItem();
    }//GEN-LAST:event_jList_SceneValueChanged

    private void jComboBox_Project_ResizeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox_Project_ResizeActionPerformed
        showPreview();
    }//GEN-LAST:event_jComboBox_Project_ResizeActionPerformed

    private void jButton_Project_PreviewActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_Project_PreviewActionPerformed
        if (previewThread != null) {
            try {
                terminated = true;
                previewThread.join();
            } catch (InterruptedException ex) {
                Logger.getLogger(JFrame_Main.class.getName()).log(Level.SEVERE, null, ex);
            }
            previewThread = null;

        }

        if (jDialog_Preview != null) {
            jDialog_Preview.setVisible(false);
            jDialog_Preview.dispose();
            jDialog_Preview = null;
        }
        
        if (SelectedScene != null) {
            FormToScene(SelectedScene);
        }

        jDialog_Preview = new JDialog_Preview();
        project = FormToProject();
        jDialog_Preview.jPanel_Preview.setSize(project.project_Resolution.getWidth(), project.project_Resolution.getHeight());
        
        jDialog_Preview.setVisible(true);
        while (jDialog_Preview.opened) try {
            Thread.sleep(100);
        } catch (InterruptedException ex) {
            Logger.getLogger(JFrame_Main.class.getName()).log(Level.SEVERE, null, ex);
        }

        previewThread = new Thread(this);
        previewMode = true;
        terminated = false;
        previewThread.start();
        
        
    }//GEN-LAST:event_jButton_Project_PreviewActionPerformed
    private String formatBytes(long b) {
        DecimalFormat df = new DecimalFormat();

        df.applyPattern("0");
        df.setMaximumFractionDigits(1);
        df.setMinimumFractionDigits(0);

        if (b < 1024) return Long.toString(b) + "Byte";
        else if(b < 1048576) return df.format(b / 1024.0) + "KB";
        else if(b < 1073741824) return df.format(b / 1048576.0) + "MB";
        else if(b < 1099511627776L) return df.format(b / 1073741824.0) + "GB";
        else return df.format(b / 1099511627776.0) + "TB";

    }
    private void jButton_Project_EncodeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_Project_EncodeActionPerformed
        if (SelectedScene != null) {
            FormToScene(SelectedScene);
        }

        Project p = FormToProject();
        
        if (JOptionPane.NO_OPTION == JOptionPane.showConfirmDialog(this, 
            "中間ファイルの作成のため、" + formatBytes((long)(p.calcTotalFrameCount() * p.project_Resolution.getWidth() * p.project_Resolution.getHeight() * 1.5))
            + "の空き容量が必要です。\n続行しますか？", "確認", JOptionPane.YES_NO_OPTION)) {

            return;
        }
        
        //ダイアログを作成
        JFileChooser f = new JFileChooser();
        f.setDialogType(JFileChooser.SAVE_DIALOG);
        f.setFileFilter(new MP4FileFilter());
        f.setMultiSelectionEnabled(false);
        if (!OpenedFileName.isEmpty()) f.setCurrentDirectory((new File(OpenedFileName)).getParentFile());
        f.setDialogTitle("動画を保存");
        
        //ダイアログを開く
        if (JFileChooser.APPROVE_OPTION == f.showSaveDialog(this)) {
            String SaveFileName = f.getSelectedFile().getAbsolutePath();
            if (jDialog_Encode != null) {
                jDialog_Encode.dispose();
                jDialog_Encode = null;
            }
            //p.SoundEncode(PathUtil.AddLastSeparator(PathUtil.getParent(SaveFileName)) + "temp" + Long.toString(System.currentTimeMillis()) + ".wav");
            
            
            jDialog_Encode = new JDialog_Encode(this, true, SaveFileName, p);
            jDialog_Encode.setVisible(true);
            
        }
    }//GEN-LAST:event_jButton_Project_EncodeActionPerformed

    private void formWindowActivated(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowActivated
        showPreview();
    }//GEN-LAST:event_formWindowActivated

    private void jButton_Scene_Change_RuleImageActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_Scene_Change_RuleImageActionPerformed
        JFileChooser f = new JFileChooser();
        f.setFileFilter(new ImageFileFilter());
        f.setMultiSelectionEnabled(false);
        f.setSelectedFile(new File(jTextField_Scene_Change_RuleImage.getText()));
        f.setDialogTitle("画像を選択");

        if (JFileChooser.APPROVE_OPTION == f.showOpenDialog(this)) {
            String s = f.getSelectedFile().getAbsolutePath();
            int index = s.lastIndexOf(File.separator) + 1;
            jTextField_Scene_Change_RuleImage.setText(s);
        }

    }//GEN-LAST:event_jButton_Scene_Change_RuleImageActionPerformed

    private void jSpinner_Scene_TimeMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jSpinner_Scene_TimeMouseEntered
        double fps = (Integer)jSpinner_Project_FPS.getValue();
        double time_min = 1.0 / fps;
        double scene_time = (Double)jSpinner_Scene_Time.getValue();

        jSpinner_Scene_Time.setToolTipText("<html>ここに、表示時間を半角数字で入力します。<br>"
                                         + "小数または整数が使用できます。<br><br>"
                                         + "有効な最小時間単位はFPSによって変動します。<br>"
                                         + "現在の設定「" + Integer.toString((int)fps) + "FPS」では、" + Double.toString(time_min) + "秒です。<br>"
                                         + "最低でもこの時間分は表示されます。<br>"
                                         + "従って、実際の表示時間は" + Double.toString(Math.max(Math.floor(scene_time / time_min) * time_min, time_min)) + "秒になります。");
    }//GEN-LAST:event_jSpinner_Scene_TimeMouseEntered

    public void run() {
        int selectedIndex = 0;
        boolean isSelection = !jList_Scene.isSelectionEmpty();
        
        if (isSelection) selectedIndex = jList_Scene.getSelectedIndex();
        
        //リストで選択されているシーンから開始する
        if (jList_Scene.isSelectionEmpty()) project.RenderBegin(0);
        else project.RenderBegin(selectedIndex);
        jList_Scene.clearSelection();

        while (!jDialog_Preview.opened) try {
            Thread.sleep(100);
        } catch (InterruptedException ex) {
            Logger.getLogger(JFrame_Main.class.getName()).log(Level.SEVERE, null, ex);
        }

        TSoundRenderer soundRenderer = new TSoundRenderer();

        Graphics2D g2 = (Graphics2D) jDialog_Preview.jPanel_Preview.getGraphics();
        g2.setBackground(jDialog_Preview.jPanel_Preview.getBackground());
        g2.clearRect(0, 0, jDialog_Preview.jPanel_Preview.getWidth(), jDialog_Preview.jPanel_Preview.getHeight());
        g2.dispose();
        
        DefaultListModel model = (DefaultListModel) jList_Scene.getModel();
        Graphics g;

        double frameTime = 1000.0 / project.project_FPS;
        double totalTime = 0;
        long afterTime, beforeTime = System.currentTimeMillis();
        long totalFrame = 0, sleepTime;
        
        while (project.RenderFrame() && (!terminated) && (!jDialog_Preview.closed)) {
            
            if (project.isNewScene()) {
                //現在描画中のシーンを選択する
                if (project.getCurrentSceneIndex() <= model.getSize() - 1) { 
                    jList_Scene.clearSelection();
                    jList_Scene.setSelectedIndex(project.getCurrentSceneIndex());
                    jList_Scene.ensureIndexIsVisible(project.getCurrentSceneIndex());
                }
                
                Scene s = project.SceneList.get(project.getCurrentSceneIndex());
                if ((new File(s.sound_BGMFile)).exists()) {
                    switch (s.sound_Control) {
                        case PLAY: {
                            TSoundLayer soundLayer = soundRenderer.LoadSoundFile(0, s.sound_BGMFile);
                            
                            if (s.sound_LoopEnabled) soundLayer.setStatus(TSoundStatusType.ループ再生);
                            else soundLayer.setStatus(TSoundStatusType.再生);
                            
                            soundLayer.setVolume(s.sound_Volume);
                            break;
                        }
                        
                        case STOP: {
                            TSoundLayer soundLayer = soundRenderer.SoundChannelList.get(0);
                            if (soundLayer != null) soundLayer.setStatus(TSoundStatusType.停止);
                            break;
                        }
                        
                        case VOLUME: {
                            TSoundLayer soundLayer = soundRenderer.SoundChannelList.get(0);
                            if (soundLayer != null) soundLayer.setVolume(s.sound_Volume);
                            break;
                        }
                    }
                }
                
                if ((new File(s.sound_SEFile)).exists()) {
                    TSoundLayer soundLayer = soundRenderer.LoadSoundFile(1, s.sound_SEFile);
                    soundLayer.setStatus(TSoundStatusType.再生);
                }

            }

            g = jDialog_Preview.jPanel_Preview.getGraphics();
            g.drawImage(project.getImageCacheBlend(), 0, 0, null);
            g.dispose();
            
            //実行後の時間を取得
            afterTime = System.currentTimeMillis();

            totalTime += frameTime;
            totalFrame++;

            //CPUに余裕のあるときのみsleepする
            //フレームスキップはしない
            
            sleepTime = (long)(totalTime - (afterTime - beforeTime));
            //jDialog_Preview.setTitle(Long.toString(sleepTime));
            
            if (sleepTime >= 10) {
                try {
                    Thread.sleep(sleepTime);
                } catch (InterruptedException ex) {
                    Logger.getLogger(JFrame_Main.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
            else {
                //beforeTime = System.currentTimeMillis();
                //totalTime = 0;
            }
        }
        previewMode = false;
        jDialog_Preview.setVisible(false);
        jDialog_Preview.dispose();
        jDialog_Preview = null;

        soundRenderer.Finalize();
        jList_Scene.setSelectedIndex(selectedIndex);


    }

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        UIManager.getInstalledLookAndFeels();
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(JFrame_Main.class.getName()).log(Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            Logger.getLogger(JFrame_Main.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            Logger.getLogger(JFrame_Main.class.getName()).log(Level.SEVERE, null, ex);
        } catch (UnsupportedLookAndFeelException ex) {
            Logger.getLogger(JFrame_Main.class.getName()).log(Level.SEVERE, null, ex);
        }

        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new JFrame_Main().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton_Project_Encode;
    private javax.swing.JButton jButton_Project_Open;
    private javax.swing.JButton jButton_Project_Preview;
    private javax.swing.JButton jButton_Project_Save;
    private javax.swing.JButton jButton_Scene_Add;
    private javax.swing.JButton jButton_Scene_Change_RuleImage;
    private javax.swing.JButton jButton_Scene_Delete;
    private javax.swing.JButton jButton_Scene_Image;
    private javax.swing.JButton jButton_Scene_Sound_BGM;
    private javax.swing.JButton jButton_Scene_Sound_SE;
    private javax.swing.JButton jButton_Scene_TimeAll;
    private javax.swing.JCheckBox jCheckBox_Scene_Sound_BGM_Loop;
    private javax.swing.JComboBox jComboBox_Project_Resize;
    private javax.swing.JComboBox jComboBox_Project_Resolution;
    private javax.swing.JComboBox jComboBox_Scene_Change;
    private javax.swing.JComboBox jComboBox_Scene_Sound_BGM_Control;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JList jList_Scene;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JPanel jPanel_Preview;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSpinner jSpinner_Project_FPS;
    private javax.swing.JSpinner jSpinner_Scene_Change_Time;
    private javax.swing.JSpinner jSpinner_Scene_Sound_BGM_Volume;
    private javax.swing.JSpinner jSpinner_Scene_Time;
    private javax.swing.JTabbedPane jTabbedPane_Scene;
    private javax.swing.JTextField jTextField_Scene_Change_RuleImage;
    private javax.swing.JTextField jTextField_Scene_Image;
    private javax.swing.JTextField jTextField_Scene_Name;
    private javax.swing.JTextField jTextField_Scene_Sound_BGM;
    private javax.swing.JTextField jTextField_Scene_Sound_SE;
    // End of variables declaration//GEN-END:variables


}
