/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package picturestoryeditor;

import java.io.File;
import java.net.URLDecoder;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


/**
 *絶対パス・相対パスの相互変換を目的に作成されたクラス
 * @author Administrator
 */
public class PathUtil {

    private static final String ABSTRACT_SEPARATOR = "||";
    private static final String RELATIVE_ELEMENT = ".." + ABSTRACT_SEPARATOR;
    public static final String CURRENT_PATH = AddLastSeparator(getCurrentPathName());
    
    public static String getCurrentPathName() {
        File F = new File(PathUtil.class.getProtectionDomain().getCodeSource().getLocation().getPath());
        try{
            return URLDecoder.decode(F.getParent(), "utf-8");
        }
        catch(Exception e){
            return "";
        }

    }

    public static String DeleteLastSeparator(String s) {
        if ((s == null) || (s.length() < 2)) return s;
        if (s.endsWith(File.separator)) return s.substring(0, s.length() - 2);
        else return s;
    }

    public static String AddLastSeparator(String s) {
        if ((s == null) || (s.isEmpty())) return s;
        if (!s.endsWith(File.separator)) return s + File.separator;
        else return s;
        
    }
    
    public static String getParent(String s) {
        if ((s == null) || (s.length() < 2)) return s;
        int i = s.lastIndexOf(File.separator, s.length() - 2);
        return s.substring(0, i);
    }
    
    public static String GetRelativePath(String Base, String Path) {
        if (Base.length() < 2) return Path;
        if (Path.isEmpty()) return "";
        
        //最後がseparatorでないならファイルと見なす
        if (!Base.endsWith(File.separator)) {
            Base = getParent(Base);
        }

        Base = AddLastSeparator(Base);

        int index = Base.length() - 1;
        int count = 0;

        //末尾から一致するところを探す
        while (true) {
            index = Base.lastIndexOf(File.separator, index);
            if (index >= 0) {
                if ((Path.length() - 1) >= index) {
                    String s = Base.substring(0, index + 1);
                    String s2 = Path.substring(0, index + 1);
                    if (s.equals(s2)) break;
                }
                count++;
                index--;
            }
            else return Path;
        }

        //不要な部分を削除
        Path = Path.substring(index + 1);
        Base = "";

        //残りをRELATIVE_ELEMENTに変換
        for (int i = 0; i < count; ++i) {
            Base += RELATIVE_ELEMENT;
        }

        try {
            Path = Path.replaceAll(Matcher.quoteReplacement(File.separator), Matcher.quoteReplacement(ABSTRACT_SEPARATOR));
        
        } catch (Exception e) {
            //見つからない場合
        }
        
        return Base + Path;
    }
    
    public static String GetAbsolutePath(String Base, String Path) {
        if (Base.length() < 2) return Path;
        if (Path.isEmpty()) return "";

        //最後がseparatorでないならファイルと見なす
        if (!Base.endsWith(File.separator)) {
            Base = getParent(Base);
        }

        Base = AddLastSeparator(Base);

        int index = 0;
        int index2 = 0;
        int count = 0;

        //何階層戻るか調べる
        while (true) {
            index = Path.indexOf(RELATIVE_ELEMENT, index);
            if (index >= 0) {
                index += RELATIVE_ELEMENT.length();
                count++;
                index2 = index;
            }
            else break;
        }

        //不要な部分を削除
        Path = Path.substring(index2);

        //count 階層戻る
        index = Base.length() - 2;
        index2 = index;
        for (int i = 0; i < count; ++i) {
            index = Base.lastIndexOf(File.separator, index);
            if (index >= 0) {
                index--;
                index2 = index;
            }
            else return "";
        }

        try {
            Path = Path.replaceAll(Matcher.quoteReplacement(ABSTRACT_SEPARATOR), Matcher.quoteReplacement(File.separator));
        } catch (Exception e) {
            //見つからない場合
        }

        return Base.substring(0, index2 + 1) + File.separator + Path;
    }
    
}
