/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package picturestoryeditor;

import java.io.File;

/**
 *
 * @author Administrator
 */
public class Scene {
    public String base_Name = "";
    public double base_Time = 3;
    public String base_ImageFile = "";

    public String sound_BGMFile = "";
    public SoundControlType sound_Control = SoundControlType.NONE;
    public int sound_Volume = 60;
    public boolean sound_LoopEnabled = false;
    public String sound_SEFile = "";

    public String text_Body = "";
    public TextPositionlType text_Position = TextPositionlType.HIDE;

    public ChangeEffectType change_Effect = ChangeEffectType.NORMAL;
    public double change_Time = 0;
    public String change_RuleImageFile = "";

    @Override
    public String toString() {
        return base_Name;
    }


    public void SaveToINI(IniFile ini, String sectionName, String keyName) {
        ini.WriteData(sectionName, keyName + "base_Name", base_Name, true);
        ini.WriteData(sectionName, keyName + "base_Time", base_Time, false);
        ini.WriteData(sectionName, keyName + "base_ImageFile", base_ImageFile, true);
        ini.WriteData(sectionName, keyName + "base_ImageFile_Relative",PathUtil.GetRelativePath(ini.FileName, base_ImageFile) , true);
        
        ini.WriteData(sectionName, keyName + "sound_BGMFile", sound_BGMFile, true);
        ini.WriteData(sectionName, keyName + "sound_BGMFile_Relative", PathUtil.GetRelativePath(ini.FileName, sound_BGMFile), true);
        ini.WriteData(sectionName, keyName + "sound_Control", sound_Control.name(), false);
        ini.WriteData(sectionName, keyName + "sound_Volume", sound_Volume, false);
        ini.WriteData(sectionName, keyName + "sound_LoopEnabled", sound_LoopEnabled, false);
        ini.WriteData(sectionName, keyName + "sound_SEFile", sound_SEFile, true);
        ini.WriteData(sectionName, keyName + "sound_SEFile_Relative", PathUtil.GetRelativePath(ini.FileName, sound_SEFile), true);
        
        ini.WriteData(sectionName, keyName + "text_Body", text_Body, true);
        ini.WriteData(sectionName, keyName + "text_Position", text_Position.name(), true);
        
        ini.WriteData(sectionName, keyName + "change_Effect", change_Effect.name(), true);
        ini.WriteData(sectionName, keyName + "change_Time", change_Time, false);
        ini.WriteData(sectionName, keyName + "change_RuleImageFile", change_RuleImageFile, true);
        ini.WriteData(sectionName, keyName + "change_RuleImageFile_Relative", PathUtil.GetRelativePath(ini.FileName, change_RuleImageFile), true);
        
    }
    
    public void LoadFromINI(IniFile ini, String sectionName, String keyName) {
        base_Name = ini.ReadData(sectionName, keyName + "base_Name", "", true);
        base_Time = ini.ReadData(sectionName, keyName + "base_Time", 3.0, false);

        base_ImageFile = PathUtil.GetAbsolutePath(ini.FileName, ini.ReadData(sectionName, keyName + "base_ImageFile_Relative", "", true));
        File f = new File(base_ImageFile);
        if ((!f.exists()) || f.isDirectory()) {
            base_ImageFile = ini.ReadData(sectionName, keyName + "base_ImageFile", "", true);
        }
        
        sound_BGMFile = PathUtil.GetAbsolutePath(ini.FileName, ini.ReadData(sectionName, keyName + "sound_BGMFile_Relative", "", true));
        f = new File(sound_BGMFile);
        if ((!f.exists()) || f.isDirectory()) {
            sound_BGMFile = ini.ReadData(sectionName, keyName + "sound_BGMFile", "", true);
        }

        sound_Control = SoundControlType.valueOf(ini.ReadData(sectionName, keyName + "sound_Control", SoundControlType.NONE.name(), false));
        sound_Volume = ini.ReadData(sectionName, keyName + "sound_Volume", 60, false);
        sound_LoopEnabled = ini.ReadData(sectionName, keyName + "sound_LoopEnabled", false, false);
        
        sound_SEFile = PathUtil.GetAbsolutePath(ini.FileName, ini.ReadData(sectionName, keyName + "sound_SEFile_Relative", "", true));
        f = new File(sound_SEFile);
        if ((!f.exists()) || f.isDirectory()) {
            sound_SEFile = ini.ReadData(sectionName, keyName + "sound_SEFile", "", true);
        }
        
        text_Body = ini.ReadData(sectionName, keyName + "text_Body", "", true);
        text_Position = TextPositionlType.valueOf(ini.ReadData(sectionName, keyName + "text_Position", TextPositionlType.HIDE.name(), true));
        
        change_Effect = ChangeEffectType.valueOf(ini.ReadData(sectionName, keyName + "change_Effect", ChangeEffectType.NORMAL.name(), true));
        change_Time = ini.ReadData(sectionName, keyName + "change_Time", 0.0, false);
        
        change_RuleImageFile = PathUtil.GetAbsolutePath(ini.FileName, ini.ReadData(sectionName, keyName + "change_RuleImageFile_Relative", "", true));
        f = new File(change_RuleImageFile);
        if ((!f.exists()) || f.isDirectory()) {
            change_RuleImageFile = ini.ReadData(sectionName, keyName + "change_RuleImageFile", "", true);
        }
        
    }
}
