/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package picturestoryeditor;

import java.net.URL;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Locale;

/**
 *
 * @author Administrator
 */
public class TSoundRenderer {
    public static final int LAYER_MAX = 16;
    public LinkedList<TSoundLayer> SoundChannelList;
    private HashMap<String, TSoundLayer> SystemSoundList;
    
    public TSoundRenderer() {
        
        SoundChannelList = new LinkedList<TSoundLayer>();
        SystemSoundList = new HashMap<String, TSoundLayer>();
        
        for (int i = 0; i <= LAYER_MAX; ++i) SoundChannelList.add(null);
        
    }
    
    public TSoundLayer LoadSoundFile(int Channel, String FileName) {
        TSoundLayer layer = SoundChannelList.get(Channel);
        if ((layer != null)) layer.Finalize();

        //拡張子を取り出す
        int index = -1;
        index = FileName.lastIndexOf(".");
        String ext = FileName.substring(index).toLowerCase(Locale.ENGLISH);


        layer = new TWaveSoundLayer();
        layer.Load(FileName);
        SoundChannelList.set(Channel, layer);
        return layer;
    }
    
    public TSoundLayer LoadSystemSoundFile(String FileName) {
        URL url = this.getClass().getResource(FileName);
        TSoundLayer layer;

        layer = SystemSoundList.get(FileName);
        if (layer != null) return layer;

        //拡張子を取り出す
        int index = -1;
        index = FileName.lastIndexOf(".");
        String ext = FileName.substring(index).toLowerCase(Locale.ENGLISH);

        layer = new TWaveSoundLayer();
        layer.Load(url);
        SystemSoundList.put(FileName, layer);
        
        return layer;
    }
    
    public void Finalize() {
        for (TSoundLayer layer : SoundChannelList) {
            if (layer != null) layer.Finalize();
        }
        
        for (TSoundLayer layer : SystemSoundList.values()) {
            if (layer != null) layer.Finalize();
        }
    }
    

}
