/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package picturestoryeditor;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.sound.sampled.Control;
import javax.sound.sampled.FloatControl;
import javax.sound.sampled.Line;
import javax.sound.sampled.LineEvent;
import javax.sound.sampled.LineListener;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.UnsupportedAudioFileException;

/**
 *
 * @author Administrator
 */
public class TWaveSoundLayer extends TSoundLayer implements LineListener{
    public Clip clip;
    private boolean running = false;

    public TWaveSoundLayer() {
        try {
            clip = AudioSystem.getClip();
            clip.addLineListener(this);
        } catch (LineUnavailableException ex) {
            Logger.getLogger(TWaveSoundLayer.class.getName()).log(Level.SEVERE, null, ex);
            clip = null;
        }

    }
    
    public void Load(String FileName) {
        Finalize();
        URL url = null;
        try {
            url = new URL(FileName);
            
        } catch (MalformedURLException ex) {
            try {
                url = (new File(FileName)).toURI().toURL();
                //Logger.getLogger(TWaveSoundLayer.class.getName()).log(Level.SEVERE, null, ex);
            } catch (MalformedURLException ex1) {
                Logger.getLogger(TWaveSoundLayer.class.getName()).log(Level.SEVERE, null, ex1);
            }
        }
        
        try {
            Load(url);
        } catch (Exception ex) {
            this.FileName = "";
            IsLoaded = false;
            Logger.getLogger(TWaveSoundLayer.class.getName()).log(Level.SEVERE, null, ex);
            return;
        }
        this.FileName = FileName;
    }
    
    public void setPan (int p) {
        if (IsLoaded) {
            if (clip.isControlSupported(FloatControl.Type.PAN)) {
                FloatControl con = (FloatControl) clip.getControl(FloatControl.Type.PAN);
                con.setValue(VolumeToDB(p));
                Pan = p;
            }
            
        }
    }
    
    public void setVolume (int v) {
        if (IsLoaded) {
            if (clip.isControlSupported(FloatControl.Type.MASTER_GAIN)) {
                FloatControl con = (FloatControl) clip.getControl(FloatControl.Type.MASTER_GAIN);
                con.setValue(VolumeToDB(v));
                //con.setValue(0.0f);
                Volume = v;
            }
            
        }
    }

    public void setStatus(TSoundStatusType s) {
        if (IsLoaded) {
            switch (s) {
                case ループ再生:
                    clip.stop();
                    if (Status == TSoundStatusType.一時停止) clip.setFramePosition(Position);
                    else clip.setFramePosition(0);

                    clip.setLoopPoints(0, -1);
                    clip.loop(Clip.LOOP_CONTINUOUSLY);
                    running = true;

                    break;
                    
                case 再生:
                    clip.stop();
                    if (Status == TSoundStatusType.一時停止) clip.setFramePosition(Position);
                    else clip.setFramePosition(0);
                    
                    if (Status == TSoundStatusType.ループ再生) clip.loop(0);
                    else clip.start();
                    running = true;
                    break;
                    
                case 一時停止:
                    Position = clip.getFramePosition();
                    clip.stop();
                    running = false;

                    break;
                    
                case 停止:
                    clip.stop();
                    running = false;
                    break;
            }
        }
        Status = s;
    }
    
    @Override
    public void Finalize() {
        if (clip == null) return; 
        clip.stop();
        clip.drain();
        clip.close();
    }

    @Override
    public void Load(URL url) {

        try {
            AudioInputStream ais = AudioSystem.getAudioInputStream(url);

            try {
                clip.open(ais);
                IsLoaded = true;
                //stream.close();
            } catch (LineUnavailableException ex) {
                Logger.getLogger(TWaveSoundLayer.class.getName()).log(Level.SEVERE, null, ex);
            }
        } catch (UnsupportedAudioFileException ex) {
            Logger.getLogger(TWaveSoundLayer.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(TWaveSoundLayer.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }


    @Override
    public boolean isRunning() {
        return running;
    }

    public void update(LineEvent event) {
        if (event.getType() == LineEvent.Type.STOP) running = false;
    }
    
}
