/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package picturestoryeditor.effect;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

/**
 * トランジションを行うクラス
 * @author Administrator
 */
public class Fade {
    
    private BufferedImage beforeImage;
    private BufferedImage afterImage;
    private BufferedImage destImage;
    private int frameMax;
    private int frameMax2;
    private int frameCount;
    private float alphaValue;
    private float incAlphaValue;
    private float incAlphaValue2;
    private boolean fadeInMode = false;
    
    public void RenderBegin(BufferedImage beforeImage, BufferedImage afterImage, BufferedImage destImage, int frameMax) {
        
        this.beforeImage = beforeImage;
        this.afterImage = afterImage;
        this.destImage = destImage;
        this.frameMax = frameMax / 2;
        this.frameMax2 = this.frameMax + (frameMax % 2);
        this.frameCount = 0;
        this.alphaValue = 1;
        if (this.frameMax != 0) this.incAlphaValue = -1.0f / this.frameMax;
        if (this.frameMax2 != 0) this.incAlphaValue2 = 1.0f / (this.frameMax2 + 1);
    }
    
    public void RenderEnd() {
        beforeImage = null;
        afterImage = null;
        destImage = null;
    }
    
    public boolean RenderFrame() {
        if ((frameMax == 0) && (frameMax2 == 1)) {
            return false;
        }
        if (frameCount < frameMax) {
            alphaValue += incAlphaValue;
            if (1 < alphaValue) alphaValue = 1;
            else if (0 > alphaValue) alphaValue = 0;
            
            Graphics2D g2 = destImage.createGraphics();
            g2.setBackground(Color.BLACK);
            g2.clearRect(0, 0, destImage.getWidth(), destImage.getHeight());
            g2.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, alphaValue));
            
            //次のシーンをフェードイン
            if (fadeInMode) {
                g2.drawImage(afterImage, 0, 0, null);
            }

            //現在のシーンをフェードアウト
            else {
                g2.drawImage(beforeImage, 0, 0, null);
            }
            g2.dispose();
            
            //最後のフレーム
            if (frameCount == frameMax - 1) {
                
                //フェードイン中ではない
                if (!fadeInMode) {
                    alphaValue = 0;
                
                    //フェードインモードに切り替える
                    fadeInMode = true;
                    frameCount = -1;
                    incAlphaValue = incAlphaValue2;
                    frameMax = frameMax2;
                }
            }
            frameCount++;
            return true;
        }
        else return false;
    }

}
